require 'spec_helper'

module QueuemrTest
  describe 'Queuemr E2E Test of Individual Endpoints for Clusters and Jobs and JobTypes' do
    include_context 'request metadata'

    before(:all) do
      @emr_cluster_id = 'j-2G1EGLM9ASYXP' if ENV['TEST_ENV'].eql? 'staging'
      @emr_cluster_id = '' if ENV['TEST_ENV'].eql? 'prod'
      @job_type = "#{ENV['NAMESPACE']}-#{ENV['TEST_ENV']}-#{ENV['EKS_ENV']}"
      @priority = 'LOWEST'
      @s3_bucket = 'cht-mdr-staging' if ((ENV['EKS_ENV'].nil?) && (ENV['TEST_ENV'].eql? 'staging'))
      @s3_bucket = 'cht-mdr-staging' if ((ENV['EKS_ENV'].eql? 'virginia-1') && (ENV['TEST_ENV'].eql? 'staging'))
      @job_type_input_json = {"executionTimeoutInMin": 120,"jarLocation": "s3://#{@s3_bucket}/jars/dataset-artifact-gen-1.0.246.jar","largeSizeThreshold": 3221225472,"livySubmitCmd": "val args = Array(\"--jobid=:JOBID\", \"--payload=:PAYLOAD\", \"--mdrArtLoc=s3://#{@s3_bucket}/\", \"--glueDB=svc_mdr\", \"--spring.profiles.active=prod\", \"--sendJobStatus\", \"--updateTableMetadata=true\",\"--activeTableVersion=true\"); com.cloudhealth.springboot.loader.EnhancedJarLauncher.main(args);","maxRetry": 3,"name": "#{@job_type}","orderingStrategy": "INSERTION_ORDER","orderingStrategyInput": nil,"priorityCatalogs": ["report"],"queuedJobTimeoutInMin": 360,"rollbarToken": "5199fde40066470193affef96c0bb310","sparkSubmitCmd": "spark-submit --deploy-mode cluster --class org.springframework.boot.loader.JarLauncher :JARLOCATION --payload=:PAYLOAD --spring.profiles.active=prod --mdrArtLoc=s3://#{@s3_bucket}/ --glueDB=svc_mdr --stopSparkSession --updateTableMetadata=true --activeTableVersion=true","status": "ACTIVE","stealthJobType": nil}
      puts @job_type_input_json.to_s
    end

    xit 'CAN CREATE JOB TYPE' do
      wrap_request do
        variables = {
          'input': Base64.encode64(@job_type_input_json.to_s)
        }
        graphql url(service: service),
                format_request(
                  :createJobType,
                  service: service
                ),
                variables, headers
        expect_success_graphql
        check(:createJobType, service: service)
        expect(json_body[:data][:createJobType][:executionTimeoutInMin]).to eql '120'
        expect(json_body[:data][:createJobType][:name]).to eql @job_type
      end
    end
  end
end
